Subject: [PATCH 0/2] optimize string hashing in xdiff

From: Alexander Monakov <[email-masked]>
Date: Mon, 28 Jul 2025 22:05:18 +0300

Hello world,

I've noticed the work by Phillip Wood regarding hash optimization for xdiff.
I want to point out that it is possible to speed up the existing hash by 1.5x
matching the peformance of xxhash (but without introducing a dependendency).

The additive variant of the djb2 hash is used in ELF symbol lookup, and
Noah Goldstein contributed a well-optimized implementation to Glibc.

I'm taking the refactoring patch from Phillip and building on top of it.

Alexander Monakov (1):
  xdiff: optimize xdl_hash_record_verbatim

Phillip Wood (1):
  xdiff: refactor xdl_hash_record()

 xdiff/xutils.c | 66 +++++++++++++++++++++++++++++++++++++++++++-------
 xdiff/xutils.h | 10 +++++++-
 2 files changed, 66 insertions(+), 10 deletions(-)

-- 
2.44.2